# class Hash

A `Hash` is a dictionary-like collection of unique keys and their values. Also called associative arrays, they are similar to Arrays, but where an `Array` uses integers as its index, a `Hash` allows you to use any object type.

Hashes enumerate their values in the order that the corresponding keys were inserted.

A `Hash` can be easily created by using its implicit form:

    grades = { "Jane Doe" => 10, "Jim Doe" => 6 }

Hashes allow an alternate syntax for keys that are symbols. Instead of

    options = { :font_size => 10, :font_family => "Arial" }

You could write it as:

    options = { font_size: 10, font_family: "Arial" }

Each named key is a symbol you can access in hash:

    options[:font_size]  # => 10

A `Hash` can also be created through its `::new` method:

    grades = Hash.new
    grades["Dorothy Doe"] = 9

Hashes have a default value that is returned when accessing keys that do not exist in the hash. If no default is set `nil` is used. You can set the default value by sending it as an argument to `Hash.new`:

    grades = Hash.new(0)

Or by using the `default=` method:

    grades = {"Timmy Doe" => 8}
    grades.default = 0

Accessing a value in a `Hash` requires using its key:

    puts grades["Jane Doe"] # => 0

### Common Uses¶ ↑

Hashes are an easy way to represent data structures, such as

    books         = {}
    books[:matz]  = "The Ruby Programming Language"
    books[:black] = "The Well-Grounded Rubyist"

Hashes are also commonly used as a way to have named parameters in functions. Note that no brackets are used below. If a hash is the last argument on a method call, no braces are needed, thus creating a really clean interface:

    Person.create(name: "John Doe", age: 27)

    def self.create(params)
      @name = params[:name]
      @age  = params[:age]
    end

### `Hash` Keys¶ ↑

Two objects refer to the same hash key when their `hash` value is identical and the two objects are `eql?` to each other.

A user-defined class may be used as a hash key if the `hash` and `eql?` methods are overridden to provide meaningful behavior. By default, separate instances refer to separate hash keys.

A typical implementation of `hash` is based on the object's data while `eql?` is usually aliased to the overridden `==` method:

    class Book
      attr_reader :author, :title

      def initialize(author, title)
        @author = author
        @title = title
      end

      def ==(other)
        self.class === other and
          other.author == @author and
          other.title == @title
      end

      alias eql? ==

      def hash
        @author.hash ^ @title.hash # XOR
      end
    end

    book1 = Book.new 'matz', 'Ruby in a Nutshell'
    book2 = Book.new 'matz', 'Ruby in a Nutshell'

    reviews = {}

    reviews[book1] = 'Great reference!'
    reviews[book2] = 'Nice and compact!'

    reviews.length #=> 1

See also Object#hash and `Object#eql?`

### Public Class Methods

Hash[ key, value, ... ] → new_hash click to toggle source
Hash[ [ [key, value], ... ] ] → new_hash
Hash[ object ] → new_hash

Creates a new hash populated with the given objects.

Similar to the literal `{ key => value, ... }`. In the first form, keys and values occur in pairs, so there must be an even number of arguments.

The second and third form take a single argument which is either an array of key-value pairs or an object convertible to a hash.

    Hash["a", 100, "b", 200]             #=> {"a"=>100, "b"=>200}
    Hash[ [ ["a", 100], ["b", 200] ] ]   #=> {"a"=>100, "b"=>200}
    Hash["a" => 100, "b" => 200]         #=> {"a"=>100, "b"=>200}

    static VALUE
    rb_hash_s_create(int argc, VALUE *argv, VALUE klass)
    {
        VALUE hash, tmp;

        if (argc == 1) {
            tmp = rb_hash_s_try_convert(Qnil, argv[0]);
            if (!NIL_P(tmp)) {
                hash = hash_alloc(klass);
                if (RHASH_AR_TABLE_P(tmp)) {
                    ar_copy(hash, tmp);
                }
                else {
                    RHASH_ST_TABLE_SET(hash, st_copy(RHASH_ST_TABLE(tmp)));
                }
                return hash;
            }

            tmp = rb_check_array_type(argv[0]);
            if (!NIL_P(tmp)) {
                long i;

                hash = hash_alloc(klass);
                for (i = 0; i < RARRAY_LEN(tmp); ++i) {
                    VALUE e = RARRAY_AREF(tmp, i);
                    VALUE v = rb_check_array_type(e);
                    VALUE key, val = Qnil;

                    if (NIL_P(v)) {
    #if 0 /* refix in the next release */
                        rb_raise(rb_eArgError, "wrong element type %s at %ld (expected array)",
                                 rb_builtin_class_name(e), i);

    #else
                        rb_warn("wrong element type %s at %ld (expected array)",
                                rb_builtin_class_name(e), i);
                        rb_warn("ignoring wrong elements is deprecated, remove them explicitly");
                        rb_warn("this causes ArgumentError in the next release");
                        continue;
    #endif
                    }
                    switch (RARRAY_LEN(v)) {
                      default:
                        rb_raise(rb_eArgError, "invalid number of elements (%ld for 1..2)",
                                 RARRAY_LEN(v));
                      case 2:
                        val = RARRAY_AREF(v, 1);
                      case 1:
                        key = RARRAY_AREF(v, 0);
                        rb_hash_aset(hash, key, val);
                    }
                }
                return hash;
            }
        }
        if (argc % 2 != 0) {
            rb_raise(rb_eArgError, "odd number of arguments for Hash");
        }

        hash = hash_alloc(klass);
        rb_hash_bulk_insert(argc, argv, hash);
        hash_verify(hash);
        return hash;
    }

new → new_hash click to toggle source
new(obj) → new_hash
new {|hash, key| block } → new_hash

Returns a new, empty hash. If this hash is subsequently accessed by a key that doesn't correspond to a hash entry, the value returned depends on the style of `new` used to create the hash. In the first form, the access returns `nil`. If obj is specified, this single object will be used for all default values. If a block is specified, it will be called with the hash object and the key, and should return the default value. It is the block's responsibility to store the value in the hash if required.

    h = Hash.new("Go Fish")
    h["a"] = 100
    h["b"] = 200
    h["a"]           #=> 100
    h["c"]           #=> "Go Fish"
    # The following alters the single default object
    h["c"].upcase!   #=> "GO FISH"
    h["d"]           #=> "GO FISH"
    h.keys           #=> ["a", "b"]

    # While this creates a new default object each time
    h = Hash.new { |hash, key| hash[key] = "Go Fish: #{key}" }
    h["c"]           #=> "Go Fish: c"
    h["c"].upcase!   #=> "GO FISH: C"
    h["d"]           #=> "Go Fish: d"
    h.keys           #=> ["c", "d"]

    static VALUE
    rb_hash_initialize(int argc, VALUE *argv, VALUE hash)
    {
        VALUE ifnone;

        rb_hash_modify(hash);
        if (rb_block_given_p()) {
            rb_check_arity(argc, 0, 0);
            ifnone = rb_block_proc();
            SET_PROC_DEFAULT(hash, ifnone);
        }
        else {
            rb_check_arity(argc, 0, 1);
            ifnone = argc == 0 ? Qnil : argv[0];
            RHASH_SET_IFNONE(hash, ifnone);
        }

        return hash;
    }

try_convert(obj) → hash or nil click to toggle source

Try to convert obj into a hash, using `to_hash` method. Returns converted hash or nil if obj cannot be converted for any reason.

    Hash.try_convert({1=>2})   # => {1=>2}
    Hash.try_convert("1=>2")   # => nil

    static VALUE
    rb_hash_s_try_convert(VALUE dummy, VALUE hash)
    {
        return rb_check_hash_type(hash);
    }

### Public Instance Methods

hash < other → true or false click to toggle source

Returns `true` if hash is subset of other.

    h1 = {a:1, b:2}
    h2 = {a:1, b:2, c:3}
    h1 < h2    #=> true
    h2 < h1    #=> false
    h1 < h1    #=> false

    static VALUE
    rb_hash_lt(VALUE hash, VALUE other)
    {
        other = to_hash(other);
        if (RHASH_SIZE(hash) >= RHASH_SIZE(other)) return Qfalse;
        return hash_le(hash, other);
    }

hash <= other → true or false click to toggle source

Returns `true` if hash is subset of other or equals to other.

    h1 = {a:1, b:2}
    h2 = {a:1, b:2, c:3}
    h1 <= h2   #=> true
    h2 <= h1   #=> false
    h1 <= h1   #=> true

    static VALUE
    rb_hash_le(VALUE hash, VALUE other)
    {
        other = to_hash(other);
        if (RHASH_SIZE(hash) > RHASH_SIZE(other)) return Qfalse;
        return hash_le(hash, other);
    }

hsh == other_hash → true or false click to toggle source

Equality—Two hashes are equal if they each contain the same number of keys and if each key-value pair is equal to (according to `Object#==`) the corresponding elements in the other hash.

    h1 = { "a" => 1, "c" => 2 }
    h2 = { 7 => 35, "c" => 2, "a" => 1 }
    h3 = { "a" => 1, "c" => 2, 7 => 35 }
    h4 = { "a" => 1, "d" => 2, "f" => 35 }
    h1 == h2   #=> false
    h2 == h3   #=> true
    h3 == h4   #=> false

The orders of each hashes are not compared.

    h1 = { "a" => 1, "c" => 2 }
    h2 = { "c" => 2, "a" => 1 }
    h1 == h2   #=> true

    static VALUE
    rb_hash_equal(VALUE hash1, VALUE hash2)
    {
        return hash_equal(hash1, hash2, FALSE);
    }

hash > other → true or false click to toggle source

Returns `true` if other is subset of hash.

    h1 = {a:1, b:2}
    h2 = {a:1, b:2, c:3}
    h1 > h2    #=> false
    h2 > h1    #=> true
    h1 > h1    #=> false

    static VALUE
    rb_hash_gt(VALUE hash, VALUE other)
    {
        other = to_hash(other);
        if (RHASH_SIZE(hash) <= RHASH_SIZE(other)) return Qfalse;
        return hash_le(other, hash);
    }

hash >= other → true or false click to toggle source

Returns `true` if other is subset of hash or equals to hash.

    h1 = {a:1, b:2}
    h2 = {a:1, b:2, c:3}
    h1 >= h2   #=> false
    h2 >= h1   #=> true
    h1 >= h1   #=> true

    static VALUE
    rb_hash_ge(VALUE hash, VALUE other)
    {
        other = to_hash(other);
        if (RHASH_SIZE(hash) < RHASH_SIZE(other)) return Qfalse;
        return hash_le(other, hash);
    }

hsh[key] → value click to toggle source

Element Reference—Retrieves the value object corresponding to the key object. If not found, returns the default value (see `Hash::new` for details).

    h = { "a" => 100, "b" => 200 }
    h["a"]   #=> 100
    h["c"]   #=> nil

    VALUE
    rb_hash_aref(VALUE hash, VALUE key)
    {
        st_data_t val;

        if (RHASH_AR_TABLE_P(hash) && ar_lookup(hash, key, &val)) {
            return (VALUE)val;
        }
        else if (RHASH_ST_TABLE_P(hash) && st_lookup(RHASH_ST_TABLE(hash), key, &val)) {
            return (VALUE)val;
        }
        hash_verify(hash);
        return rb_hash_default_value(hash, key);
    }

hsh[key] = value → value click to toggle source

## Element Assignment¶ ↑

Associates the value given by `value` with the key given by `key`.

    h = { "a" => 100, "b" => 200 }
    h["a"] = 9
    h["c"] = 4
    h   #=> {"a"=>9, "b"=>200, "c"=>4}
    h.store("d", 42) #=> 42
    h   #=> {"a"=>9, "b"=>200, "c"=>4, "d"=>42}

`key` should not have its value changed while it is in use as a key (an `unfrozen String` passed as a key will be duplicated and frozen).

    a = "a"
    b = "b".freeze
    h = { a => 100, b => 200 }
    h.key(100).equal? a #=> false
    h.key(200).equal? b #=> true

    VALUE
    rb_hash_aset(VALUE hash, VALUE key, VALUE val)
    {
        int iter_lev = RHASH_ITER_LEV(hash);

        rb_hash_modify(hash);

        if (RHASH_TABLE_NULL_P(hash)) {
            if (iter_lev > 0) no_new_key();
            ar_alloc_table(hash);
        }

        if (RHASH_TYPE(hash) == &identhash || rb_obj_class(key) != rb_cString) {
            RHASH_UPDATE_ITER(hash, iter_lev, key, hash_aset, val);
        }
        else {
            RHASH_UPDATE_ITER(hash, iter_lev, key, hash_aset_str, val);
        }
        return val;
    }

any? [{ |(key, value)| block }] → true or false click to toggle source
any?(pattern) → true or false

See also `Enumerable#any?`

    static VALUE
    rb_hash_any_p(int argc, VALUE *argv, VALUE hash)
    {
        VALUE args[2];
        args[0] = Qfalse;

        rb_check_arity(argc, 0, 1);
        if (RHASH_EMPTY_P(hash)) return Qfalse;
        if (argc) {
            if (rb_block_given_p()) {
                rb_warn("given block not used");
            }
            args[1] = argv[0];

            rb_hash_foreach(hash, any_p_i_pattern, (VALUE)args);
        }
        else {
            if (!rb_block_given_p()) {
                /* yields pairs, never false */
                return Qtrue;
            }
            if (rb_block_arity() > 1)
                rb_hash_foreach(hash, any_p_i_fast, (VALUE)args);
            else
                rb_hash_foreach(hash, any_p_i, (VALUE)args);
        }
        return args[0];
    }

assoc(obj) → an_array or nil click to toggle source

Searches through the hash comparing obj with the key using `==`. Returns the key-value pair (two elements array) or `nil` if no match is found. See `Array#assoc`.

    h = {"colors"  => ["red", "blue", "green"],
         "letters" => ["a", "b", "c" ]}
    h.assoc("letters")  #=> ["letters", ["a", "b", "c"]]
    h.assoc("foo")      #=> nil

    VALUE
    rb_hash_assoc(VALUE hash, VALUE key)
    {
        st_table *table;
        const struct st_hash_type *orighash;
        VALUE args[2];

        if (RHASH_EMPTY_P(hash)) return Qnil;

        ar_force_convert_table(hash, __FILE__, __LINE__);
        HASH_ASSERT(RHASH_ST_TABLE_P(hash));
        table = RHASH_ST_TABLE(hash);
        orighash = table->type;

        if (orighash != &identhash) {
            VALUE value;
            struct reset_hash_type_arg ensure_arg;
            struct st_hash_type assochash;

            assochash.compare = assoc_cmp;
            assochash.hash = orighash->hash;
            table->type = &assochash;
            args[0] = hash;
            args[1] = key;
            ensure_arg.hash = hash;
            ensure_arg.orighash = orighash;
            value = rb_ensure(lookup2_call, (VALUE)&args, reset_hash_type, (VALUE)&ensure_arg);
            if (value != Qundef) return rb_assoc_new(key, value);
        }

        args[0] = key;
        args[1] = Qnil;
        rb_hash_foreach(hash, assoc_i, (VALUE)args);
        return args[1];
    }

clear → hsh click to toggle source

Removes all key-value pairs from hsh.

    h = { "a" => 100, "b" => 200 }   #=> {"a"=>100, "b"=>200}
    h.clear                          #=> {}

    VALUE
    rb_hash_clear(VALUE hash)
    {
        rb_hash_modify_check(hash);

        if (RHASH_ITER_LEV(hash) > 0) {
            rb_hash_foreach(hash, clear_i, 0);
        }
        else if (RHASH_AR_TABLE_P(hash)) {
            ar_clear(hash);
        }
        else {
            st_clear(RHASH_ST_TABLE(hash));
        }

        return hash;
    }

compact → new_hash click to toggle source

Returns a new hash with the nil values/key pairs removed

    h = { a: 1, b: false, c: nil }
    h.compact     #=> { a: 1, b: false }
    h             #=> { a: 1, b: false, c: nil }

    static VALUE
    rb_hash_compact(VALUE hash)
    {
        VALUE result = rb_hash_new();
        if (!RHASH_EMPTY_P(hash)) {
            rb_hash_foreach(hash, set_if_not_nil, result);
        }
        return result;
    }

compact! → hsh or nil click to toggle source

Removes all nil values from the hash. Returns nil if no changes were made, otherwise returns the hash.

    h = { a: 1, b: false, c: nil }
    h.compact!     #=> { a: 1, b: false }

    static VALUE
    rb_hash_compact_bang(VALUE hash)
    {
        st_index_t n;
        rb_hash_modify_check(hash);
        n = RHASH_SIZE(hash);
        if (n) {
            rb_hash_foreach(hash, delete_if_nil, hash);
            if (n != RHASH_SIZE(hash))
                return hash;
        }
        return Qnil;
    }

compare_by_identity → hsh click to toggle source

Makes hsh compare its keys by their identity, i.e. it will consider exact same objects as same keys.

    h1 = { "a" => 100, "b" => 200, :c => "c" }
    h1["a"]        #=> 100
    h1.compare_by_identity
    h1.compare_by_identity? #=> true
    h1["a".dup]    #=> nil  # different objects.
    h1[:c]         #=> "c"  # same symbols are all same.

    static VALUE
    rb_hash_compare_by_id(VALUE hash)
    {
        VALUE tmp;
        st_table *identtable;

        if (rb_hash_compare_by_id_p(hash)) return hash;

        rb_hash_modify_check(hash);
        ar_force_convert_table(hash, __FILE__, __LINE__);
        HASH_ASSERT(RHASH_ST_TABLE_P(hash));

        tmp = hash_alloc(0);
        identtable = rb_init_identtable_with_size(RHASH_SIZE(hash));
        RHASH_ST_TABLE_SET(tmp, identtable);
        rb_hash_foreach(hash, rb_hash_rehash_i, (VALUE)tmp);
        st_free_table(RHASH_ST_TABLE(hash));
        RHASH_ST_TABLE_SET(hash, identtable);
        RHASH_ST_CLEAR(tmp);
        rb_gc_force_recycle(tmp);

        return hash;
    }

compare_by_identity? → true or false click to toggle source

Returns `true` if hsh will compare its keys by their identity. Also see `Hash#compare_by_identity`.

    MJIT_FUNC_EXPORTED VALUE
    rb_hash_compare_by_id_p(VALUE hash)
    {
        if (RHASH_ST_TABLE_P(hash) && RHASH_ST_TABLE(hash)->type == &identhash) {
            return Qtrue;
        }
        else {
            return Qfalse;
        }
    }

default(key=nil) → obj click to toggle source

Returns the default value, the value that would be returned by hsh if key did not exist in hsh. See also `Hash::new` and `Hash#default=`.

    h = Hash.new                            #=> {}
    h.default                               #=> nil
    h.default(2)                            #=> nil

    h = Hash.new("cat")                     #=> {}
    h.default                               #=> "cat"
    h.default(2)                            #=> "cat"

    h = Hash.new {|h,k| h[k] = k.to_i*10}   #=> {}
    h.default                               #=> nil
    h.default(2)                            #=> 20

    static VALUE
    rb_hash_default(int argc, VALUE *argv, VALUE hash)
    {
        VALUE args[2], ifnone;

        rb_check_arity(argc, 0, 1);
        ifnone = RHASH_IFNONE(hash);
        if (FL_TEST(hash, HASH_PROC_DEFAULT)) {
            if (argc == 0) return Qnil;
            args[0] = hash;
            args[1] = argv[0];
            return rb_funcallv(ifnone, id_yield, 2, args);
        }
        return ifnone;
    }

default = obj → obj click to toggle source

Sets the default value, the value returned for a key that does not exist in the hash. It is not possible to set the default to a `Proc` that will be executed on each key lookup.

    h = { "a" => 100, "b" => 200 }
    h.default = "Go fish"
    h["a"]     #=> 100
    h["z"]     #=> "Go fish"
    # This doesn't do what you might hope...
    h.default = proc do |hash, key|
      hash[key] = key + key
    end
    h[2]       #=> #<Proc:0x401b3948@-:6>
    h["cat"]   #=> #<Proc:0x401b3948@-:6>

    static VALUE
    rb_hash_set_default(VALUE hash, VALUE ifnone)
    {
        rb_hash_modify_check(hash);
        SET_DEFAULT(hash, ifnone);
        return ifnone;
    }

default_proc → anObject click to toggle source

If `Hash::new` was invoked with a block, return that block, otherwise return `nil`.

    h = Hash.new {|h,k| h[k] = k*k }   #=> {}
    p = h.default_proc                 #=> #<Proc:0x401b3d08@-:1>
    a = []                             #=> []
    p.call(a, 2)
    a                                  #=> [nil, nil, 4]

    static VALUE
    rb_hash_default_proc(VALUE hash)
    {
        if (FL_TEST(hash, HASH_PROC_DEFAULT)) {
            return RHASH_IFNONE(hash);
        }
        return Qnil;
    }

default_proc = proc_obj or nil click to toggle source

Sets the default proc to be executed on each failed key lookup.

    h.default_proc = proc do |hash, key|
      hash[key] = key + key
    end
    h[2]       #=> 4
    h["cat"]   #=> "catcat"

    VALUE
    rb_hash_set_default_proc(VALUE hash, VALUE proc)
    {
        VALUE b;

        rb_hash_modify_check(hash);
        if (NIL_P(proc)) {
            SET_DEFAULT(hash, proc);
            return proc;
        }
        b = rb_check_convert_type_with_id(proc, T_DATA, "Proc", idTo_proc);
        if (NIL_P(b) || !rb_obj_is_proc(b)) {
            rb_raise(rb_eTypeError,
                     "wrong default_proc type %s (expected Proc)",
                     rb_obj_classname(proc));
        }
        proc = b;
        SET_PROC_DEFAULT(hash, proc);
        return proc;
    }

delete(key) → value click to toggle source
delete(key) {| key | block } → value

Deletes the key-value pair and returns the value from hsh whose key is equal to key. If the key is not found, it returns nil. If the optional code block is given and the key is not found, pass in the key and return the result of block.

    h = { "a" => 100, "b" => 200 }
    h.delete("a")                              #=> 100
    h.delete("z")                              #=> nil
    h.delete("z") { |el| "#{el} not found" }   #=> "z not found"

    static VALUE
    rb_hash_delete_m(VALUE hash, VALUE key)
    {
        VALUE val;

        rb_hash_modify_check(hash);
        val = rb_hash_delete_entry(hash, key);

        if (val != Qundef) {
            return val;
        }
        else {
            if (rb_block_given_p()) {
                return rb_yield(key);
            }
            else {
                return Qnil;
            }
        }
    }

delete_if {| key, value | block } → hsh click to toggle source
delete_if → an_enumerator

Deletes every key-value pair from hsh for which block evaluates to `true`.

If no block is given, an enumerator is returned instead.

    h = { "a" => 100, "b" => 200, "c" => 300 }
    h.delete_if {|key, value| key >= "b" }   #=> {"a"=>100}

    VALUE
    rb_hash_delete_if(VALUE hash)
    {
        RETURN_SIZED_ENUMERATOR(hash, 0, 0, hash_enum_size);
        rb_hash_modify_check(hash);
        if (!RHASH_TABLE_EMPTY_P(hash)) {
            rb_hash_foreach(hash, delete_if_i, hash);
        }
        return hash;
    }

dig(key, ...) → object click to toggle source

Extracts the nested value specified by the sequence of key objects by calling `dig` at each step, returning `nil` if any intermediate step is `nil`.

    h = { foo: {bar: {baz: 1}}}

    h.dig(:foo, :bar, :baz)     #=> 1
    h.dig(:foo, :zot, :xyz)     #=> nil

    g = { foo: [10, 11, 12] }
    g.dig(:foo, 1)              #=> 11
    g.dig(:foo, 1, 0)           #=> TypeError: Integer does not have #dig method
    g.dig(:foo, :bar)           #=> TypeError: no implicit conversion of Symbol into Integer

    static VALUE
    rb_hash_dig(int argc, VALUE *argv, VALUE self)
    {
        rb_check_arity(argc, 1, UNLIMITED_ARGUMENTS);
        self = rb_hash_aref(self, *argv);
        if (!--argc) return self;
        ++argv;
        return rb_obj_dig(argc, argv, self, Qnil);
    }

each {| key, value | block } → hsh click to toggle source
each_pair {| key, value | block } → hsh
each → an_enumerator
each_pair → an_enumerator

Calls block once for each key in hsh, passing the key-value pair as parameters.

If no block is given, an enumerator is returned instead.

    h = { "a" => 100, "b" => 200 }
    h.each {|key, value| puts "#{key} is #{value}" }

produces:

    a is 100
    b is 200

    static VALUE
    rb_hash_each_pair(VALUE hash)
    {
        RETURN_SIZED_ENUMERATOR(hash, 0, 0, hash_enum_size);
        if (rb_block_arity() > 1)
            rb_hash_foreach(hash, each_pair_i_fast, 0);
        else
            rb_hash_foreach(hash, each_pair_i, 0);
        return hash;
    }

each_key {| key | block } → hsh click to toggle source
each_key → an_enumerator

Calls block once for each key in hsh, passing the key as a parameter.

If no block is given, an enumerator is returned instead.

    h = { "a" => 100, "b" => 200 }
    h.each_key {|key| puts key }

produces:

    a
    b

    static VALUE
    rb_hash_each_key(VALUE hash)
    {
        RETURN_SIZED_ENUMERATOR(hash, 0, 0, hash_enum_size);
        rb_hash_foreach(hash, each_key_i, 0);
        return hash;
    }

each_pair {| key, value | block } → hsh click to toggle source
each_pair → an_enumerator

Calls block once for each key in hsh, passing the key-value pair as parameters.

If no block is given, an enumerator is returned instead.

    h = { "a" => 100, "b" => 200 }
    h.each {|key, value| puts "#{key} is #{value}" }

produces:

    a is 100
    b is 200

    static VALUE
    rb_hash_each_pair(VALUE hash)
    {
        RETURN_SIZED_ENUMERATOR(hash, 0, 0, hash_enum_size);
        if (rb_block_arity() > 1)
            rb_hash_foreach(hash, each_pair_i_fast, 0);
        else
            rb_hash_foreach(hash, each_pair_i, 0);
        return hash;
    }

each_value {| value | block } → hsh click to toggle source
each_value → an_enumerator

Calls block once for each key in hsh, passing the value as a parameter.

If no block is given, an enumerator is returned instead.

    h = { "a" => 100, "b" => 200 }
    h.each_value {|value| puts value }

produces:

    100
    200

    static VALUE
    rb_hash_each_value(VALUE hash)
    {
        RETURN_SIZED_ENUMERATOR(hash, 0, 0, hash_enum_size);
        rb_hash_foreach(hash, each_value_i, 0);
        return hash;
    }

empty? → true or false click to toggle source

Returns `true` if hsh contains no key-value pairs.

    {}.empty?   #=> true

    static VALUE
    rb_hash_empty_p(VALUE hash)
    {
        return RHASH_EMPTY_P(hash) ? Qtrue : Qfalse;
    }

eql?(other) → true or false click to toggle source

Returns `true` if hash and other are both hashes with the same content. The orders of each hashes are not compared.

    static VALUE
    rb_hash_eql(VALUE hash1, VALUE hash2)
    {
        return hash_equal(hash1, hash2, TRUE);
    }

fetch(key [, default] ) → obj click to toggle source
fetch(key) {| key | block } → obj

Returns a value from the hash for the given key. If the key can't be found, there are several options: With no other arguments, it will raise a `KeyError` exception; if default is given, then that will be returned; if the optional code block is specified, then that will be run and its result returned.

    h = { "a" => 100, "b" => 200 }
    h.fetch("a")                            #=> 100
    h.fetch("z", "go fish")                 #=> "go fish"
    h.fetch("z") { |el| "go fish, #{el}"}   #=> "go fish, z"

The following example shows that an exception is raised if the key is not found and a default value is not supplied.

    h = { "a" => 100, "b" => 200 }
    h.fetch("z")

produces:

    prog.rb:2:in `fetch': key not found (KeyError)
     from prog.rb:2

    static VALUE
    rb_hash_fetch_m(int argc, VALUE *argv, VALUE hash)
    {
        VALUE key;
        st_data_t val;
        long block_given;

        rb_check_arity(argc, 1, 2);
        key = argv[0];

        block_given = rb_block_given_p();
        if (block_given && argc == 2) {
            rb_warn("block supersedes default value argument");
        }
        if (RHASH_AR_TABLE_P(hash) && ar_lookup(hash, key, &val)) {
            return (VALUE)val;
        }
        else if (RHASH_ST_TABLE_P(hash) && st_lookup(RHASH_ST_TABLE(hash), key, &val)) {
            return (VALUE)val;
        }
        if (block_given) return rb_yield(key);
        if (argc == 1) {
            VALUE desc = rb_protect(rb_inspect, key, 0);
            if (NIL_P(desc)) {
                desc = rb_any_to_s(key);
            }
            desc = rb_str_ellipsize(desc, 65);
            rb_key_err_raise(rb_sprintf("key not found: %"PRIsVALUE, desc), hash, key);
        }
        hash_verify(hash);
        return argv[1];
    }

fetch_values(key, ...) → array click to toggle source
fetch_values(key, ...) { |key| block } → array

Returns an array containing the values associated with the given keys but also raises `KeyError` when one of keys can't be found. Also see `Hash#values_at` and `Hash#fetch`.

    h = { "cat" => "feline", "dog" => "canine", "cow" => "bovine" }

    h.fetch_values("cow", "cat")                   #=> ["bovine", "feline"]
    h.fetch_values("cow", "bird")                  # raises KeyError
    h.fetch_values("cow", "bird") { |k| k.upcase } #=> ["bovine", "BIRD"]

    VALUE
    rb_hash_fetch_values(int argc, VALUE *argv, VALUE hash)
    {
        VALUE result = rb_ary_new2(argc);
        long i;

        for (i=0; i<argc; i++) {
            rb_ary_push(result, rb_hash_fetch(hash, argv[i]));
        }
        return result;
    }

filter {|key, value| block} → a_hash click to toggle source
filter → an_enumerator

Returns a new hash consisting of entries for which the block returns true.

If no block is given, an enumerator is returned instead.

    h = { "a" => 100, "b" => 200, "c" => 300 }
    h.select {|k,v| k > "a"}  #=> {"b" => 200, "c" => 300}
    h.select {|k,v| v < 200}  #=> {"a" => 100}

`Hash#filter` is an alias for `Hash#select`.

    VALUE
    rb_hash_select(VALUE hash)
    {
        VALUE result;

        RETURN_SIZED_ENUMERATOR(hash, 0, 0, hash_enum_size);
        result = rb_hash_new();
        if (!RHASH_EMPTY_P(hash)) {
            rb_hash_foreach(hash, select_i, result);
        }
        return result;
    }

filter! {| key, value | block } → hsh or nil click to toggle source
filter! → an_enumerator

Equivalent to `Hash#keep_if`, but returns `nil` if no changes were made.

`Hash#filter!` is an alias for `Hash#select!`.

    VALUE
    rb_hash_select_bang(VALUE hash)
    {
        st_index_t n;

        RETURN_SIZED_ENUMERATOR(hash, 0, 0, hash_enum_size);
        rb_hash_modify_check(hash);
        n = RHASH_SIZE(hash);
        if (!n) return Qnil;
        rb_hash_foreach(hash, keep_if_i, hash);
        if (n == RHASH_SIZE(hash)) return Qnil;
        return hash;
    }

flatten → an_array click to toggle source
flatten(level) → an_array

Returns a new array that is a one-dimensional flattening of this hash. That is, for every key or value that is an array, extract its elements into the new array. Unlike `Array#flatten`, this method does not flatten recursively by default. The optional level argument determines the level of recursion to flatten.

    a =  {1=> "one", 2 => [2,"two"], 3 => "three"}
    a.flatten    # => [1, "one", 2, [2, "two"], 3, "three"]
    a.flatten(2) # => [1, "one", 2, 2, "two", 3, "three"]

    static VALUE
    rb_hash_flatten(int argc, VALUE *argv, VALUE hash)
    {
        VALUE ary;

        rb_check_arity(argc, 0, 1);

        if (argc) {
            int level = NUM2INT(argv[0]);

            if (level == 0) return rb_hash_to_a(hash);

            ary = rb_ary_new_capa(RHASH_SIZE(hash) * 2);
            rb_hash_foreach(hash, flatten_i, ary);
            level--;

            if (level > 0) {
                VALUE ary_flatten_level = INT2FIX(level);
                rb_funcallv(ary, id_flatten_bang, 1, &ary_flatten_level);
            }
            else if (level < 0) {
                /* flatten recursively */
                rb_funcallv(ary, id_flatten_bang, 0, 0);
            }
        }
        else {
            ary = rb_ary_new_capa(RHASH_SIZE(hash) * 2);
            rb_hash_foreach(hash, flatten_i, ary);
        }

        return ary;
    }

has_key?(key) → true or false click to toggle source

Returns `true` if the given key is present in hsh.

    h = { "a" => 100, "b" => 200 }
    h.has_key?("a")   #=> true
    h.has_key?("z")   #=> false

Note that `include?` and `member?` do not test member equality using `==` as do other Enumerables.

See also `Enumerable#include?`

    MJIT_FUNC_EXPORTED VALUE
    rb_hash_has_key(VALUE hash, VALUE key)
    {
        if (RHASH_AR_TABLE_P(hash) && ar_lookup(hash, key, 0)) {
            return Qtrue;
        }
        else if (RHASH_ST_TABLE_P(hash) && st_lookup(RHASH_ST_TABLE(hash), key, 0)) {
            return Qtrue;
        }
        return Qfalse;
    }

has_value?(value) → true or false click to toggle source

Returns `true` if the given value is present for some key in hsh.

    h = { "a" => 100, "b" => 200 }
    h.value?(100)   #=> true
    h.value?(999)   #=> false

    static VALUE
    rb_hash_has_value(VALUE hash, VALUE val)
    {
        VALUE data[2];

        data[0] = Qfalse;
        data[1] = val;
        rb_hash_foreach(hash, rb_hash_search_value, (VALUE)data);
        return data[0];
    }

hash → integer click to toggle source

Compute a hash-code for this hash. Two hashes with the same content will have the same hash code (and will compare using `eql?`).

See also Object#hash.

    static VALUE
    rb_hash_hash(VALUE hash)
    {
        st_index_t size = RHASH_SIZE(hash);
        st_index_t hval = rb_hash_start(size);
        hval = rb_hash_uint(hval, (st_index_t)rb_hash_hash);
        if (size) {
            rb_hash_foreach(hash, hash_i, (VALUE)&hval);
        }
        hval = rb_hash_end(hval);
        return ST2FIX(hval);
    }

include?(key) → true or false click to toggle source

Returns `true` if the given key is present in hsh.

    h = { "a" => 100, "b" => 200 }
    h.has_key?("a")   #=> true
    h.has_key?("z")   #=> false

Note that `include?` and `member?` do not test member equality using `==` as do other Enumerables.

See also `Enumerable#include?`

    MJIT_FUNC_EXPORTED VALUE
    rb_hash_has_key(VALUE hash, VALUE key)
    {
        if (RHASH_AR_TABLE_P(hash) && ar_lookup(hash, key, 0)) {
            return Qtrue;
        }
        else if (RHASH_ST_TABLE_P(hash) && st_lookup(RHASH_ST_TABLE(hash), key, 0)) {
            return Qtrue;
        }
        return Qfalse;
    }

to_s → string click to toggle source
inspect → string

Return the contents of this hash as a string.

    h = { "c" => 300, "a" => 100, "d" => 400, "c" => 300  }
    h.to_s   #=> "{\"c\"=>300, \"a\"=>100, \"d\"=>400}"

    static VALUE
    rb_hash_inspect(VALUE hash)
    {
        if (RHASH_EMPTY_P(hash))
            return rb_usascii_str_new2("{}");
        return rb_exec_recursive(inspect_hash, hash, 0);
    }

Also aliased as: to_s
invert → new_hash click to toggle source

Returns a new hash created by using hsh's values as keys, and the keys as values. If a key with the same value already exists in the hsh, then the last one defined will be used, the earlier value(s) will be discarded.

    h = { "n" => 100, "m" => 100, "y" => 300, "d" => 200, "a" => 0 }
    h.invert   #=> {0=>"a", 100=>"m", 200=>"d", 300=>"y"}

If there is no key with the same value, `Hash#invert` is involutive.

    h = { a: 1, b: 3, c: 4 }
    h.invert.invert == h #=> true

The condition, no key with the same value, can be tested by comparing the size of inverted hash.

    # no key with the same value
    h = { a: 1, b: 3, c: 4 }
    h.size == h.invert.size #=> true

    # two (or more) keys has the same value
    h = { a: 1, b: 3, c: 1 }
    h.size == h.invert.size #=> false

    static VALUE
    rb_hash_invert(VALUE hash)
    {
        VALUE h = rb_hash_new_with_size(RHASH_SIZE(hash));

        rb_hash_foreach(hash, rb_hash_invert_i, h);
        return h;
    }

keep_if {| key, value | block } → hsh click to toggle source
keep_if → an_enumerator

Deletes every key-value pair from hsh for which block evaluates to `false`.

If no block is given, an enumerator is returned instead.

See also `Hash#select!`.

    VALUE
    rb_hash_keep_if(VALUE hash)
    {
        RETURN_SIZED_ENUMERATOR(hash, 0, 0, hash_enum_size);
        rb_hash_modify_check(hash);
        if (!RHASH_TABLE_EMPTY_P(hash)) {
            rb_hash_foreach(hash, keep_if_i, hash);
        }
        return hash;
    }

key(value) → key click to toggle source

Returns the key of an occurrence of a given value. If the value is not found, returns `nil`.

    h = { "a" => 100, "b" => 200, "c" => 300, "d" => 300 }
    h.key(200)   #=> "b"
    h.key(300)   #=> "c"
    h.key(999)   #=> nil

    static VALUE
    rb_hash_key(VALUE hash, VALUE value)
    {
        VALUE args[2];

        args[0] = value;
        args[1] = Qnil;

        rb_hash_foreach(hash, key_i, (VALUE)args);

        return args[1];
    }

key?(key) → true or false click to toggle source

Returns `true` if the given key is present in hsh.

    h = { "a" => 100, "b" => 200 }
    h.has_key?("a")   #=> true
    h.has_key?("z")   #=> false

Note that `include?` and `member?` do not test member equality using `==` as do other Enumerables.

See also `Enumerable#include?`

    MJIT_FUNC_EXPORTED VALUE
    rb_hash_has_key(VALUE hash, VALUE key)
    {
        if (RHASH_AR_TABLE_P(hash) && ar_lookup(hash, key, 0)) {
            return Qtrue;
        }
        else if (RHASH_ST_TABLE_P(hash) && st_lookup(RHASH_ST_TABLE(hash), key, 0)) {
            return Qtrue;
        }
        return Qfalse;
    }

keys → array click to toggle source

Returns a new array populated with the keys from this hash. See also `Hash#values`.

    h = { "a" => 100, "b" => 200, "c" => 300, "d" => 400 }
    h.keys   #=> ["a", "b", "c", "d"]

    MJIT_FUNC_EXPORTED VALUE
    rb_hash_keys(VALUE hash)
    {
        st_index_t size = RHASH_SIZE(hash);
        VALUE keys =  rb_ary_new_capa(size);

        if (size == 0) return keys;

        if (ST_DATA_COMPATIBLE_P(VALUE)) {
            RARRAY_PTR_USE_TRANSIENT(keys, ptr, {
                if (RHASH_AR_TABLE_P(hash)) {
                    size = ar_keys(hash, ptr, size);
                }
                else {
                    st_table *table = RHASH_ST_TABLE(hash);
                    size = st_keys(table, ptr, size);
                }
            });
            rb_gc_writebarrier_remember(keys);
            rb_ary_set_len(keys, size);
        }
        else {
            rb_hash_foreach(hash, keys_i, keys);
        }

        return keys;
    }

length → integer click to toggle source

Returns the number of key-value pairs in the hash.

    h = { "d" => 100, "a" => 200, "v" => 300, "e" => 400 }
    h.size          #=> 4
    h.delete("a")   #=> 200
    h.size          #=> 3
    h.length        #=> 3

`Hash#length` is an alias for `Hash#size`.

    VALUE
    rb_hash_size(VALUE hash)
    {
        return INT2FIX(RHASH_SIZE(hash));
    }

member?(key) → true or false click to toggle source

Returns `true` if the given key is present in hsh.

    h = { "a" => 100, "b" => 200 }
    h.has_key?("a")   #=> true
    h.has_key?("z")   #=> false

Note that `include?` and `member?` do not test member equality using `==` as do other Enumerables.

See also `Enumerable#include?`

    MJIT_FUNC_EXPORTED VALUE
    rb_hash_has_key(VALUE hash, VALUE key)
    {
        if (RHASH_AR_TABLE_P(hash) && ar_lookup(hash, key, 0)) {
            return Qtrue;
        }
        else if (RHASH_ST_TABLE_P(hash) && st_lookup(RHASH_ST_TABLE(hash), key, 0)) {
            return Qtrue;
        }
        return Qfalse;
    }

merge(other_hash1, other_hash2, ...) → new_hash click to toggle source
merge(other_hash1, other_hash2, ...) {|key, oldval, newval| block}
→ new_hash

Returns a new hash that combines the contents of the receiver and the contents of the given hashes.

If no block is given, entries with duplicate keys are overwritten with the values from each `other_hash` successively, otherwise the value for each duplicate key is determined by calling the block with the key, its value in the receiver and its value in each `other_hash`.

When called without any argument, returns a copy of the receiver.

    h1 = { "a" => 100, "b" => 200 }
    h2 = { "b" => 246, "c" => 300 }
    h3 = { "b" => 357, "d" => 400 }
    h1.merge          #=> {"a"=>100, "b"=>200}
    h1.merge(h2)      #=> {"a"=>100, "b"=>246, "c"=>300}
    h1.merge(h2, h3)  #=> {"a"=>100, "b"=>357, "c"=>300, "d"=>400}
    h1.merge(h2) {|key, oldval, newval| newval - oldval}
                      #=> {"a"=>100, "b"=>46,  "c"=>300}
    h1.merge(h2, h3) {|key, oldval, newval| newval - oldval}
                      #=> {"a"=>100, "b"=>311, "c"=>300, "d"=>400}
    h1                #=> {"a"=>100, "b"=>200}

    static VALUE
    rb_hash_merge(int argc, VALUE *argv, VALUE self)
    {
        return rb_hash_update(argc, argv, rb_hash_dup(self));
    }

merge!(other_hash1, other_hash2, ...) → hsh click to toggle source
merge!(other_hash1, other_hash2, ...) {|key, oldval, newval| block}

Adds the contents of the given hashes to the receiver.

If no block is given, entries with duplicate keys are overwritten with the values from each `other_hash` successively, otherwise the value for each duplicate key is determined by calling the block with the key, its value in the receiver and its value in each `other_hash`.

    h1 = { "a" => 100, "b" => 200 }
    h1.merge!          #=> {"a"=>100, "b"=>200}
    h1                 #=> {"a"=>100, "b"=>200}

    h1 = { "a" => 100, "b" => 200 }
    h2 = { "b" => 246, "c" => 300 }
    h1.merge!(h2)      #=> {"a"=>100, "b"=>246, "c"=>300}
    h1                 #=> {"a"=>100, "b"=>246, "c"=>300}

    h1 = { "a" => 100, "b" => 200 }
    h2 = { "b" => 246, "c" => 300 }
    h3 = { "b" => 357, "d" => 400 }
    h1.merge!(h2, h3)
                       #=> {"a"=>100, "b"=>357, "c"=>300, "d"=>400}
    h1                 #=> {"a"=>100, "b"=>357, "c"=>300, "d"=>400}

    h1 = { "a" => 100, "b" => 200 }
    h2 = { "b" => 246, "c" => 300 }
    h3 = { "b" => 357, "d" => 400 }
    h1.merge!(h2, h3) {|key, v1, v2| v1 }
                       #=> {"a"=>100, "b"=>200, "c"=>300, "d"=>400}
    h1                 #=> {"a"=>100, "b"=>200, "c"=>300, "d"=>400}

`Hash#update` is an alias for `Hash#merge!`.

    static VALUE
    rb_hash_update(int argc, VALUE *argv, VALUE self)
    {
        int i;
        bool block_given = rb_block_given_p();

        rb_hash_modify(self);
        for (i = 0; i < argc; i++){
           VALUE hash = to_hash(argv[i]);
           if (block_given) {
               rb_hash_foreach(hash, rb_hash_update_block_i, self);
           }
           else {
               rb_hash_foreach(hash, rb_hash_update_i, self);
           }
        }
        return self;
    }

rassoc(obj) → an_array or nil click to toggle source

Searches through the hash comparing obj with the value using `==`. Returns the first key-value pair (two-element array) that matches. See also `Array#rassoc`.

    a = {1=> "one", 2 => "two", 3 => "three", "ii" => "two"}
    a.rassoc("two")    #=> [2, "two"]
    a.rassoc("four")   #=> nil

    VALUE
    rb_hash_rassoc(VALUE hash, VALUE obj)
    {
        VALUE args[2];

        args[0] = obj;
        args[1] = Qnil;
        rb_hash_foreach(hash, rassoc_i, (VALUE)args);
        return args[1];
    }

rehash → hsh click to toggle source

Rebuilds the hash based on the current hash values for each key. If values of key objects have changed since they were inserted, this method will reindex hsh. If `Hash#rehash` is called while an iterator is traversing the hash, a `RuntimeError` will be raised in the iterator.

    a = [ "a", "b" ]
    c = [ "c", "d" ]
    h = { a => 100, c => 300 }
    h[a]       #=> 100
    a[0] = "z"
    h[a]       #=> nil
    h.rehash   #=> {["z", "b"]=>100, ["c", "d"]=>300}
    h[a]       #=> 100

    VALUE
    rb_hash_rehash(VALUE hash)
    {
        VALUE tmp;
        st_table *tbl;

        if (RHASH_ITER_LEV(hash) > 0) {
            rb_raise(rb_eRuntimeError, "rehash during iteration");
        }
        rb_hash_modify_check(hash);
        if (RHASH_AR_TABLE_P(hash)) {
            tmp = hash_alloc(0);
            ar_alloc_table(tmp);
            rb_hash_foreach(hash, rb_hash_rehash_i, (VALUE)tmp);
            ar_free_and_clear_table(hash);
            ar_copy(hash, tmp);
            ar_free_and_clear_table(tmp);
        }
        else if (RHASH_ST_TABLE_P(hash)) {
            st_table *old_tab = RHASH_ST_TABLE(hash);
            tmp = hash_alloc(0);
            tbl = st_init_table_with_size(old_tab->type, old_tab->num_entries);
            RHASH_ST_TABLE_SET(tmp, tbl);
            rb_hash_foreach(hash, rb_hash_rehash_i, (VALUE)tmp);
            st_free_table(old_tab);
            RHASH_ST_TABLE_SET(hash, tbl);
            RHASH_ST_CLEAR(tmp);
        }
        hash_verify(hash);
        return hash;
    }

reject {|key, value| block} → a_hash click to toggle source
reject → an_enumerator

Returns a new hash consisting of entries for which the block returns false.

If no block is given, an enumerator is returned instead.

    h = { "a" => 100, "b" => 200, "c" => 300 }
    h.reject {|k,v| k < "b"}  #=> {"b" => 200, "c" => 300}
    h.reject {|k,v| v > 100}  #=> {"a" => 100}

    VALUE
    rb_hash_reject(VALUE hash)
    {
        VALUE result;

        RETURN_SIZED_ENUMERATOR(hash, 0, 0, hash_enum_size);
        if (RTEST(ruby_verbose)) {
            VALUE klass;
            if (HAS_EXTRA_STATES(hash, klass)) {
                rb_warn("extra states are no longer copied: %+"PRIsVALUE, hash);
            }
        }
        result = rb_hash_new();
        if (!RHASH_EMPTY_P(hash)) {
            rb_hash_foreach(hash, reject_i, result);
        }
        return result;
    }

reject! {| key, value | block } → hsh or nil click to toggle source
reject! → an_enumerator

Equivalent to `Hash#delete_if`, but returns `nil` if no changes were made.

    VALUE
    rb_hash_reject_bang(VALUE hash)
    {
        st_index_t n;

        RETURN_SIZED_ENUMERATOR(hash, 0, 0, hash_enum_size);
        rb_hash_modify(hash);
        n = RHASH_SIZE(hash);
        if (!n) return Qnil;
        rb_hash_foreach(hash, delete_if_i, hash);
        if (n == RHASH_SIZE(hash)) return Qnil;
        return hash;
    }

replace(other_hash) → hsh click to toggle source

Replaces the contents of hsh with the contents of other_hash.

    h = { "a" => 100, "b" => 200 }
    h.replace({ "c" => 300, "d" => 400 })   #=> {"c"=>300, "d"=>400}

    static VALUE
    rb_hash_replace(VALUE hash, VALUE hash2)
    {
        rb_hash_modify_check(hash);
        if (hash == hash2) return hash;
        hash2 = to_hash(hash2);

        COPY_DEFAULT(hash, hash2);

        rb_hash_clear(hash);

        if (RHASH_AR_TABLE_P(hash)) {
            if (RHASH_AR_TABLE_P(hash2)) {
                ar_copy(hash, hash2);
            }
            else {
                goto st_to_st;
            }
        }
        else {
            if (RHASH_AR_TABLE_P(hash2)) ar_force_convert_table(hash2, __FILE__, __LINE__);
          st_to_st:
            RHASH_TBL_RAW(hash)->type = RHASH_ST_TABLE(hash2)->type;
            rb_hash_foreach(hash2, replace_i, hash);
        }

        return hash;
    }

select {|key, value| block} → a_hash click to toggle source
select → an_enumerator

Returns a new hash consisting of entries for which the block returns true.

If no block is given, an enumerator is returned instead.

    h = { "a" => 100, "b" => 200, "c" => 300 }
    h.select {|k,v| k > "a"}  #=> {"b" => 200, "c" => 300}
    h.select {|k,v| v < 200}  #=> {"a" => 100}

`Hash#filter` is an alias for `Hash#select`.

    VALUE
    rb_hash_select(VALUE hash)
    {
        VALUE result;

        RETURN_SIZED_ENUMERATOR(hash, 0, 0, hash_enum_size);
        result = rb_hash_new();
        if (!RHASH_EMPTY_P(hash)) {
            rb_hash_foreach(hash, select_i, result);
        }
        return result;
    }

select! {| key, value | block } → hsh or nil click to toggle source
select! → an_enumerator

Equivalent to `Hash#keep_if`, but returns `nil` if no changes were made.

`Hash#filter!` is an alias for `Hash#select!`.

    VALUE
    rb_hash_select_bang(VALUE hash)
    {
        st_index_t n;

        RETURN_SIZED_ENUMERATOR(hash, 0, 0, hash_enum_size);
        rb_hash_modify_check(hash);
        n = RHASH_SIZE(hash);
        if (!n) return Qnil;
        rb_hash_foreach(hash, keep_if_i, hash);
        if (n == RHASH_SIZE(hash)) return Qnil;
        return hash;
    }

shift → anArray or obj click to toggle source

Removes a key-value pair from hsh and returns it as the two-item array `[` key, value `]`, or the hash's default value if the hash is empty.

    h = { 1 => "a", 2 => "b", 3 => "c" }
    h.shift   #=> [1, "a"]
    h         #=> {2=>"b", 3=>"c"}

    static VALUE
    rb_hash_shift(VALUE hash)
    {
        struct shift_var var;

        rb_hash_modify_check(hash);
        if (RHASH_AR_TABLE_P(hash)) {
            var.key = Qundef;
            if (RHASH_ITER_LEV(hash) == 0) {
                if (ar_shift(hash, &var.key, &var.val)) {
                    return rb_assoc_new(var.key, var.val);
                }
            }
            else {
                rb_hash_foreach(hash, shift_i_safe, (VALUE)&var);
                if (var.key != Qundef) {
                    rb_hash_delete_entry(hash, var.key);
                    return rb_assoc_new(var.key, var.val);
                }
            }
        }
        if (RHASH_ST_TABLE_P(hash)) {
            var.key = Qundef;
            if (RHASH_ITER_LEV(hash) == 0) {
                if (st_shift(RHASH_ST_TABLE(hash), &var.key, &var.val)) {
                    return rb_assoc_new(var.key, var.val);
                }
            }
            else {
                rb_hash_foreach(hash, shift_i_safe, (VALUE)&var);
                if (var.key != Qundef) {
                    rb_hash_delete_entry(hash, var.key);
                    return rb_assoc_new(var.key, var.val);
                }
            }
        }
        return rb_hash_default_value(hash, Qnil);
    }

size → integer click to toggle source

Returns the number of key-value pairs in the hash.

    h = { "d" => 100, "a" => 200, "v" => 300, "e" => 400 }
    h.size          #=> 4
    h.delete("a")   #=> 200
    h.size          #=> 3
    h.length        #=> 3

`Hash#length` is an alias for `Hash#size`.

    VALUE
    rb_hash_size(VALUE hash)
    {
        return INT2FIX(RHASH_SIZE(hash));
    }

slice(*keys) → a_hash click to toggle source

Returns a hash containing only the given keys and their values.

    h = { a: 100, b: 200, c: 300 }
    h.slice(:a)           #=> {:a=>100}
    h.slice(:b, :c, :d)   #=> {:b=>200, :c=>300}

    static VALUE
    rb_hash_slice(int argc, VALUE *argv, VALUE hash)
    {
        int i;
        VALUE key, value, result;

        if (argc == 0 || RHASH_EMPTY_P(hash)) {
            return rb_hash_new();
        }
        result = rb_hash_new_with_size(argc);

        for (i = 0; i < argc; i++) {
            key = argv[i];
            value = rb_hash_lookup2(hash, key, Qundef);
            if (value != Qundef)
                rb_hash_aset(result, key, value);
        }

        return result;
    }

store(key, value) → value click to toggle source

## Element Assignment¶ ↑

Associates the value given by `value` with the key given by `key`.

    h = { "a" => 100, "b" => 200 }
    h["a"] = 9
    h["c"] = 4
    h   #=> {"a"=>9, "b"=>200, "c"=>4}
    h.store("d", 42) #=> 42
    h   #=> {"a"=>9, "b"=>200, "c"=>4, "d"=>42}

`key` should not have its value changed while it is in use as a key (an `unfrozen String` passed as a key will be duplicated and frozen).

    a = "a"
    b = "b".freeze
    h = { a => 100, b => 200 }
    h.key(100).equal? a #=> false
    h.key(200).equal? b #=> true

    VALUE
    rb_hash_aset(VALUE hash, VALUE key, VALUE val)
    {
        int iter_lev = RHASH_ITER_LEV(hash);

        rb_hash_modify(hash);

        if (RHASH_TABLE_NULL_P(hash)) {
            if (iter_lev > 0) no_new_key();
            ar_alloc_table(hash);
        }

        if (RHASH_TYPE(hash) == &identhash || rb_obj_class(key) != rb_cString) {
            RHASH_UPDATE_ITER(hash, iter_lev, key, hash_aset, val);
        }
        else {
            RHASH_UPDATE_ITER(hash, iter_lev, key, hash_aset_str, val);
        }
        return val;
    }

to_a → array click to toggle source

Converts hsh to a nested array of `[` key, value `]` arrays.

    h = { "c" => 300, "a" => 100, "d" => 400, "c" => 300  }
    h.to_a   #=> [["c", 300], ["a", 100], ["d", 400]]

    static VALUE
    rb_hash_to_a(VALUE hash)
    {
        VALUE ary;

        ary = rb_ary_new_capa(RHASH_SIZE(hash));
        rb_hash_foreach(hash, to_a_i, ary);
        OBJ_INFECT(ary, hash);

        return ary;
    }

to_h → hsh or new_hash click to toggle source
to_h {|key, value| block } → new_hash

Returns `self`. If called on a subclass of `Hash`, converts the receiver to a `Hash` object.

If a block is given, the results of the block on each pair of the receiver will be used as pairs.

    static VALUE
    rb_hash_to_h(VALUE hash)
    {
        if (rb_block_given_p()) {
            return rb_hash_to_h_block(hash);
        }
        if (rb_obj_class(hash) != rb_cHash) {
            const VALUE flags = RBASIC(hash)->flags;
            hash = hash_dup(hash, rb_cHash, flags & HASH_PROC_DEFAULT);
        }
        return hash;
    }

to_hash → hsh click to toggle source

Returns `self`.

    static VALUE
    rb_hash_to_hash(VALUE hash)
    {
        return hash;
    }

to_proc → proc click to toggle source

Returns a `Proc` which maps keys to values.

    h = {a:1, b:2}
    hp = h.to_proc
    hp.call(:a)          #=> 1
    hp.call(:b)          #=> 2
    hp.call(:c)          #=> nil
    [:a, :b, :c].map(&h) #=> [1, 2, nil]

    static VALUE
    rb_hash_to_proc(VALUE hash)
    {
        return rb_func_proc_new(hash_proc_call, hash);
    }

to_s()
Alias for: inspect
transform_keys {|key| block } → new_hash click to toggle source
transform_keys → an_enumerator

Returns a new hash with the results of running the block once for every key. This method does not change the values.

    h = { a: 1, b: 2, c: 3 }
    h.transform_keys {|k| k.to_s }  #=> { "a" => 1, "b" => 2, "c" => 3 }
    h.transform_keys(&:to_s)        #=> { "a" => 1, "b" => 2, "c" => 3 }
    h.transform_keys.with_index {|k, i| "#{k}.#{i}" }
                                    #=> { "a.0" => 1, "b.1" => 2, "c.2" => 3 }

If no block is given, an enumerator is returned instead.

    static VALUE
    rb_hash_transform_keys(VALUE hash)
    {
        VALUE result;

        RETURN_SIZED_ENUMERATOR(hash, 0, 0, hash_enum_size);
        result = rb_hash_new();
        if (!RHASH_EMPTY_P(hash)) {
            rb_hash_foreach(hash, transform_keys_i, result);
        }

        return result;
    }

transform_keys! {|key| block } → hsh click to toggle source
transform_keys! → an_enumerator

Invokes the given block once for each key in hsh, replacing it with the new key returned by the block, and then returns hsh. This method does not change the values.

    h = { a: 1, b: 2, c: 3 }
    h.transform_keys! {|k| k.to_s }  #=> { "a" => 1, "b" => 2, "c" => 3 }
    h.transform_keys!(&:to_sym)      #=> { a: 1, b: 2, c: 3 }
    h.transform_keys!.with_index {|k, i| "#{k}.#{i}" }
                                     #=> { "a.0" => 1, "b.1" => 2, "c.2" => 3 }

If no block is given, an enumerator is returned instead.

    static VALUE
    rb_hash_transform_keys_bang(VALUE hash)
    {
        RETURN_SIZED_ENUMERATOR(hash, 0, 0, hash_enum_size);
        rb_hash_modify_check(hash);
        if (!RHASH_TABLE_EMPTY_P(hash)) {
            long i;
            VALUE pairs = rb_hash_flatten(0, NULL, hash);
            rb_hash_clear(hash);
            for (i = 0; i < RARRAY_LEN(pairs); i += 2) {
                VALUE key = RARRAY_AREF(pairs, i), new_key = rb_yield(key),
                      val = RARRAY_AREF(pairs, i+1);
                rb_hash_aset(hash, new_key, val);
            }
        }
        return hash;
    }

transform_values {|value| block } → new_hash click to toggle source
transform_values → an_enumerator

Returns a new hash with the results of running the block once for every value. This method does not change the keys.

    h = { a: 1, b: 2, c: 3 }
    h.transform_values {|v| v * v + 1 }  #=> { a: 2, b: 5, c: 10 }
    h.transform_values(&:to_s)           #=> { a: "1", b: "2", c: "3" }
    h.transform_values.with_index {|v, i| "#{v}.#{i}" }
                                         #=> { a: "1.0", b: "2.1", c: "3.2" }

If no block is given, an enumerator is returned instead.

    static VALUE
    rb_hash_transform_values(VALUE hash)
    {
        VALUE result;

        RETURN_SIZED_ENUMERATOR(hash, 0, 0, hash_enum_size);
        result = rb_hash_new_with_size(RHASH_SIZE(hash));
        if (!RHASH_EMPTY_P(hash)) {
            rb_hash_foreach(hash, transform_values_i, result);
        }

        return result;
    }

transform_values! {|value| block } → hsh click to toggle source
transform_values! → an_enumerator

Invokes the given block once for each value in hsh, replacing it with the new value returned by the block, and then returns hsh. This method does not change the keys.

    h = { a: 1, b: 2, c: 3 }
    h.transform_values! {|v| v * v + 1 }  #=> { a: 2, b: 5, c: 10 }
    h.transform_values!(&:to_s)           #=> { a: "2", b: "5", c: "10" }
    h.transform_values!.with_index {|v, i| "#{v}.#{i}" }
                                          #=> { a: "2.0", b: "5.1", c: "10.2" }

If no block is given, an enumerator is returned instead.

    static VALUE
    rb_hash_transform_values_bang(VALUE hash)
    {
        RETURN_SIZED_ENUMERATOR(hash, 0, 0, hash_enum_size);
        rb_hash_modify_check(hash);
        if (!RHASH_TABLE_EMPTY_P(hash))
            rb_hash_foreach(hash, transform_values_i, hash);
        return hash;
    }

update(other_hash1, other_hash2, ...) → hsh click to toggle source
update(other_hash1, other_hash2, ...) {|key, oldval, newval| block}

Adds the contents of the given hashes to the receiver.

If no block is given, entries with duplicate keys are overwritten with the values from each `other_hash` successively, otherwise the value for each duplicate key is determined by calling the block with the key, its value in the receiver and its value in each `other_hash`.

    h1 = { "a" => 100, "b" => 200 }
    h1.merge!          #=> {"a"=>100, "b"=>200}
    h1                 #=> {"a"=>100, "b"=>200}

    h1 = { "a" => 100, "b" => 200 }
    h2 = { "b" => 246, "c" => 300 }
    h1.merge!(h2)      #=> {"a"=>100, "b"=>246, "c"=>300}
    h1                 #=> {"a"=>100, "b"=>246, "c"=>300}

    h1 = { "a" => 100, "b" => 200 }
    h2 = { "b" => 246, "c" => 300 }
    h3 = { "b" => 357, "d" => 400 }
    h1.merge!(h2, h3)
                       #=> {"a"=>100, "b"=>357, "c"=>300, "d"=>400}
    h1                 #=> {"a"=>100, "b"=>357, "c"=>300, "d"=>400}

    h1 = { "a" => 100, "b" => 200 }
    h2 = { "b" => 246, "c" => 300 }
    h3 = { "b" => 357, "d" => 400 }
    h1.merge!(h2, h3) {|key, v1, v2| v1 }
                       #=> {"a"=>100, "b"=>200, "c"=>300, "d"=>400}
    h1                 #=> {"a"=>100, "b"=>200, "c"=>300, "d"=>400}

`Hash#update` is an alias for `Hash#merge!`.

    static VALUE
    rb_hash_update(int argc, VALUE *argv, VALUE self)
    {
        int i;
        bool block_given = rb_block_given_p();

        rb_hash_modify(self);
        for (i = 0; i < argc; i++){
           VALUE hash = to_hash(argv[i]);
           if (block_given) {
               rb_hash_foreach(hash, rb_hash_update_block_i, self);
           }
           else {
               rb_hash_foreach(hash, rb_hash_update_i, self);
           }
        }
        return self;
    }

value?(value) → true or false click to toggle source

Returns `true` if the given value is present for some key in hsh.

    h = { "a" => 100, "b" => 200 }
    h.value?(100)   #=> true
    h.value?(999)   #=> false

    static VALUE
    rb_hash_has_value(VALUE hash, VALUE val)
    {
        VALUE data[2];

        data[0] = Qfalse;
        data[1] = val;
        rb_hash_foreach(hash, rb_hash_search_value, (VALUE)data);
        return data[0];
    }

values → array click to toggle source

Returns a new array populated with the values from hsh. See also `Hash#keys`.

    h = { "a" => 100, "b" => 200, "c" => 300 }
    h.values   #=> [100, 200, 300]

    VALUE
    rb_hash_values(VALUE hash)
    {
        VALUE values;
        st_index_t size = RHASH_SIZE(hash);

        values = rb_ary_new_capa(size);
        if (size == 0) return values;

        if (ST_DATA_COMPATIBLE_P(VALUE)) {
            if (RHASH_AR_TABLE_P(hash)) {
                rb_gc_writebarrier_remember(values);
                RARRAY_PTR_USE_TRANSIENT(values, ptr, {
                    size = ar_values(hash, ptr, size);
                });
            }
            else if (RHASH_ST_TABLE_P(hash)) {
                st_table *table = RHASH_ST_TABLE(hash);
                rb_gc_writebarrier_remember(values);
                RARRAY_PTR_USE_TRANSIENT(values, ptr, {
                    size = st_values(table, ptr, size);
                });
            }
            rb_ary_set_len(values, size);
        }
        else {
            rb_hash_foreach(hash, values_i, values);
        }

        return values;
    }

values_at(key, ...) → array click to toggle source

Return an array containing the values associated with the given keys. Also see `Hash.select`.

    h = { "cat" => "feline", "dog" => "canine", "cow" => "bovine" }
    h.values_at("cow", "cat")  #=> ["bovine", "feline"]

    VALUE
    rb_hash_values_at(int argc, VALUE *argv, VALUE hash)
    {
        VALUE result = rb_ary_new2(argc);
        long i;

        for (i=0; i<argc; i++) {
            rb_ary_push(result, rb_hash_aref(hash, argv[i]));
        }
        return result;
    }